<?php
require 'config.php';
require 'functions.php';
require 'commonfuncs.php';
require 'classes/settings.php';
require 'classes/database.php';
require 'classes/language.php';

// make compatable when register_globals is off
while(list($key, $value) = each($_GET)) 
{
 $$key = stripcode($value);
} 
while(list($key, $value) = each($_POST)) 
{
 $$key = stripcode($value);
} 

$db = new database;
$settings = new settingsdata;
$admindir = $settings->admindir;
if ($admindir == '') $admindir = 'admin';
require $admindir .'/adminfunctions.php';
require $admindir .'/admincommonfuncs.php';

// Include member integration file here
$custommemberdb = false;
// include custom member db file here
if (strlen($settings->integration) > 2)
{
 $thefile = 'integration/'. $settings->integration .'.php';
 include "$thefile";
}

if ($getgoing)
{ 
 if (!$custommemberdb) $query = $db->select('password,usergroup', 'memberstable', "name='$suppliedname'", '', '');
 else $query = $db->select("$newpassword,$newusergroup", 'memberstable', "$newname='$suppliedname'", '', '');
 $row = $db->row($query);
 $actual = $row[0];
 $usergroup = $row[1];
 $canpass = false;
 if (!$custommemberdb) $admingroup = 3;
 if ((md5($suppliedpass) == $actual) && ($usergroup == $admingroup)) $canpass = true;
 if ($canpass)
 {
  echo "<font size=1><p>Administrative account verified... starting upgrade.</p>";
  // add the new stuff
  updateconfigandtables(); // add needed stuff to config.php
  updatedatabasefields(); // add any needed database fields
  removeduplicates(); // if they're victims of the old upgrade scripts, save 'em
  fixwrongtypes();  // fix any database field types if needed
  addsettings(); // add any needed settings
  misc(); // make misc changes for odd version differences  
  addlanguage(); // add any needed language variables
  fixtemplates();
  echo "</font><br><br><p><font size=2>Upgrade complete. Have a look at what changed above, particularly if you're going to need to translate new language items to your own language (you might want to copy this list of new language items), then <a href=index.php>browse</a> or <a href=". $settings->admindir ."/>administrate</a>.</p>";
 }
 else 
 {
  echo "Your username and password are not valid for an administrative account. You do not  have permission to upgrade.";
 } 
}
else
{
 $message = "<p>This will upgrade your WSN Guest database to the current version.</p>";

 $message .= "<form action=upgrade.php?getgoing=1 method=post>";
 
 $message .= "<br>Supply your administrative username and password:<br><br>Username: <input type=text name=suppliedname><br>Password: <input type=password name=suppliedpass><br><br>";

 $message .= "<input type=submit value=Upgrade>
</form>";
 echo $message;
}

function updatedatabasefields()
{
 global $db, $settings, $linkstable, $categoriestable, $commentstable, $memberstable, $membergroupstable, $debug;
 
 echo "<p>Checking for new database fields to add...</p>";

 $linkfields = ','. $settings->linkfields .',';
 $commentfields = ','. $settings->commentfields .',';
 $memberfields = ','. $settings->memberfields .',';
 $usergroupfields = ','. $settings->usergroupfields .',';
 
 $stuff = fileread("dbschema.wsn");  
 $stuff = templateextract($stuff, '<!-- BEGIN DB SCHEMA -->', '<!-- END DB SCHEMA -->');
 $stuff = str_replace('<!-- END DB SCHEMA -->', '', $stuff);
 $stuff = str_replace('<!-- BEGIN DB SCHEMA -->', '', $stuff); 
 $stuff = explode('TABLE ', $stuff);
 $num = sizeof($stuff);
 for ($x=0; $x<$num; $x++)
 {
  $pair = explode(' FIELDS ', $stuff[$x]);
  if ($pair[0] != '')
  {
   $tablename = $pair[0] .'stable';
   if ($pair[0] == 'usergroup') $tablename = 'membergroupstable';
   $tablefields = $pair[0] .'fields';
   $fieldarray = explode(',', $pair[1]);
   $n = sizeof($fieldarray);
   for ($c=0; $c<$n; $c++)
   {
    $fieldarr = explode(' ', $fieldarray[$c]);
    $fieldname = $fieldarr[0];
    if (!stristr($$tablefields, ','. $fieldname .','))
    { 
     $result = $db->query("ALTER TABLE ". $$tablename . " ADD ". $fieldarray[$c]);
     $settings->$tablefields .= ','. $fieldname;
	 $newstuff = $pair[0] .'newstuff';
	 $$newstuff .= '|||'. $fieldname .'|||';
    }
   }
  }
 }
 $settings->update('linkfields,commentfields,memberfields,usergroupfields');
 if (stristr($usergropupnewstuff, 'candownloadfiles')) $db->update('membergroupstable', 'candownloadfiels', '1', 'id>0');
 if (stristr($membernewstuff, 'validated')) $db->update('memberstable', 'validated', '1', 'id>0'); 
 echo "<br>Adding entry fields: ". str_replace('|||', ' ', $linknewstuff);
 echo "<br>Adding usergroup fields: ". str_replace('|||', ' ', $usergroupnewstuff);
 echo "<br>Adding comment fields: ". str_replace('|||', ' ', $commentnewstuff); 
 echo "<br>Adding member fields: ". str_replace('|||', ' ', $membernewstuff); 
 echo "<p>Done adding fields.</p>";
 return true;
}

function fixwrongtypes()
{
 return true;
}

function addlanguage()
{
 global $debug, $itemsadded;
 $settings = new settingsdata; // re-create, in case something changed
 $langlist = explode(',', $settings->languages);
 $num = sizeof($langlist);
 echo "<p>Appending new language from english.lng to your current languages: <br>";
 for ($c=0; $c<$num; $c++)
 {
  $thislang = $langlist[$c];
  languageappend($settings->admindir ."/english.lng", $thislang);
  echo "<p>Added these items to $thislang: ". str_replace('|||', ' ', $itemsadded) ."</p>";
  $itemsadded = '';
 }


 // remove duplicate language?


 echo "<br>Done appending languages.</p>";
 // tell user what we've done
 return true;
}

function addsettings()
{
 global $db, $metatable, $settings;
 $stuff = fileread("dbschema.wsn");
 $stuff = templateextract($stuff, '<!-- BEGIN SETTINGS SCHEMA -->', '<!-- END SETTINGS SCHEMA -->');
 $stuff = str_replace('<!-- END SETTINGS SCHEMA -->', '', $stuff);
 $stuff = str_replace('<!-- BEGIN SETTINGS SCHEMA -->', '', $stuff); 

 $settingslist = ','. $settings->allnames() .',';

 $stuff = explode('[ITEM] ', $stuff);
 $num = sizeof($stuff);
 for ($x=0; $x<$num; $x++)
 {
  $pair = explode(' [DEFAULT] ', $stuff[$x]);
  if ($pair[0] != '')
  {
   $itemname = $pair[0];
   $itemdefault = $pair[1];
   if (!stristr($settingslist, ','. $itemname .','))
   {
     $result = $db->insert('metatable', 'id,name,content', "'', '$itemname', '$itemdefault'");
    $newsettings .= '|||'. $itemname .'|||';
   }
  }
 }
 

 // inform user of what we've done
 if ($newsettings != '')
 {
  echo "<p>Adding these new settings: ";
  $show = explode('|||', $newsettings);
  $tot = sizeof($show);
  for ($q=0; $q<$tot; $q++) echo $show[$q] .' ';
  echo "</p>";
 }
 else
 {
  echo "<p>No new settings need to be added.</p>";
 }
 return true;
}


function removeduplicates()
{
 global $settings;
 $tofix[0] = 'linkfields';
 $tofix[1] = 'commentfields';
 $tofix[2] = 'memberfields';
 $tofix[3] = 'usergroupfields';
 
 $todo = sizeof($tofix);
 
 for ($s=0; $s<$todo; $s++)
 {
  $ourlist = '';
  $searcharray = explode(',', $settings->$tofix[$s]);
  $n = sizeof($searcharray);
  for ($x=0; $x<$n; $x++)
  {
   if (!stristr(','. $ourlist .',', ','. $searcharray[$x] .','))
   {
    if ($x == 0) $ourlist = $searcharray[$x];
    else $ourlist .= ','. $searcharray[$x];
   }
  }
  $settings->$tofix[$s] = $ourlist;
  $settings->update($tofix[$s]);
 }
 return true;
}

function misc()
{
 global $settings, $db;
 // remove wsn codes if they're in the old format, leave alone if they're in the new format
 if (!strstr($settings->wsncodes, '[,]')) 
 { 
  $settings->wsncodes = 'url[,]/url[,]a href="{CONTENT}"[,]/a[,]Creates a link to the typed URL.[,]regular|||b[,]/b[,]b[,]/b[,]Puts the text in bold.[,]regular|||url[,]/url[,]a href={PARAM}[,]/a[,]Creates a link around the text, pointing to the specified URL.[,]param';
  echo "<p>Erasing old format WSN Codes, inserting default new ones.</p>";
  $settings->update('wsncodes');
 }

 return true;
}

function updateconfigandtables()
{
 require 'config.php';

/* if (!$somenewtable) $stufftoadd .= '$somenewtable = \''. $prefix . 'somenew' .'\'; ';
// if (!$memberstable) $stufftoadd .= '$memberstable = \''. $prefix . 'members' .'\'; '; 
 if ($stufftoadd != '')
 {
  $towrite = '<'.'?php '. $stufftoadd .'?'.'>';
  $test = fileappend("config.php", $towrite);
  if (!$test) die("You must chmod 666 or 777 your config.php file, and then return to run this upgrade again.");
 }*/
 return true;
}

function fixtemplates()
{
 global $settings;
 echo "<p>Attempting to add custom fields back into editing templates.</p>";
 $allsets = explode(',', $settings->templates);
 $num = sizeof($allsets);
 for ($x=0; $x<$num; $x++)
 {
  $thisset = $allsets[$x];

  $links = explode(',', $settings->linkfields);
  $n = sizeof($links);
  for ($y=0; $y<$n; $y++)
  {
   $edit = fileread("$thisset/edit.tpl");
   if (!stristr($edit, $links[$y]))
   {
    $tempvar = '{ENTRY'. strtoupper($links[$y]) .'}';
    $edit = str_replace('<!-- INSERT NEW FIELDS HERE -->', '<tr>
 <td><b>'. $links[$y] .':</b></td>
 <td><input type="text" name="'. $links[$y] .'" size="30" value="'. $tempvar .'"></td>
</tr>
<!-- INSERT NEW FIELDS HERE -->', $edit);
   }
  }
  $test = filewrite("$thisset/edit.tpl", $edit);
  if (!$test) echo "<p>$thisset/edit.tpl is not properly chmoded, it can't be written to.</p>";

  $coms = explode(',', $settings->commentfields);
  $n = sizeof($coms);
  for ($y=0; $y<$n; $y++)
  {
   $edit = fileread("$thisset/editcomments.tpl");
   if (!stristr($edit, $coms[$y]))
   {
    $tempvar = '{COMMENT'. strtoupper($coms[$y]) .'}';
    $edit = str_replace('<!-- INSERT NEW FIELDS HERE -->', '<tr>
 <td><b>'. $coms[$y] .':</b></td>
 <td><input type="text" name="'. $coms[$y] .'" size="30" value="'. $tempvar .'"></td>
</tr>
<!-- INSERT NEW FIELDS HERE -->', $edit);
   }
  }
  $test = filewrite("$thisset/editcomments.tpl", $edit);
  if (!$test) echo "<p>$thisset/editcomments.tpl is not properly chmoded, it can't be written to.</p>";
 
  $mems = explode(',', $settings->memberfields);
  $n = sizeof($mems);
  for ($y=0; $y<$n; $y++)
  {
   $edit = fileread("$thisset/editmembers.tpl");
   if (!stristr($edit, $mems[$y]))
   {
    $tempvar = '{MEMBER'. strtoupper($mems[$y]) .'}';
    $edit = str_replace('<!-- INSERT NEW FIELDS HERE -->', '<tr>
 <td><b>'. $mems[$y] .':</b></td>
 <td><input type="text" name="'. $mems[$y] .'" size="30" value="'. $tempvar .'"></td>
</tr>
<!-- INSERT NEW FIELDS HERE -->', $edit);
   }
  }
  $test = filewrite("$thisset/editmembers.tpl", $edit);
  if (!$test) echo "<p>$thisset/editmembers.tpl is not properly chmoded, it can't be written to.</p>";

 }
 return true;
}

?>